window.onload= generateElements();

function generateElements(){
    //generate html input
    //get the div
    var dataForm = document.getElementById('dataForm');

    //generate title
    var titleLabel = document.createElement('LABEL');
    var titleText = document.createTextNode("Title:");
    titleLabel.appendChild(titleText);
    var title = document.createElement('INPUT');
    title.className ='title';
    title.id='title';
    title.placeholder='Enter your title';

    //generate subtitle
    var subtitleLabel = document.createElement('LABEL');
    var subtitleText = document.createTextNode("Subtitle:");
    subtitleLabel.appendChild(subtitleText);
    var subtitle = document.createElement('INPUT');
    subtitle.className ='subtitle';
    subtitle.id='subtitle';
    subtitle.placeholder='Enter your Subtitle';

    //generate Name
    var nameLabel = document.createElement('LABEL');
    var nameText = document.createTextNode("Name: ");
    nameLabel.appendChild(nameText);
    var name = document.createElement('INPUT');
    name.className ='name';
    name.id='dataNames';
    name.placeholder='Enter your chart name here';

    //create label div
    var labelDiv = document.createElement('div');
    labelDiv.id = 'dataLabel';
    labelDiv.className='dataLabel';

    //generate default label
    var origionalLabel = document.createElement('LABEL');
    var labelText = document.createTextNode("Label: ");
    origionalLabel.appendChild(labelText);
    var label = document.createElement('INPUT');
    label.className = 'labels';
    label.name ='labels[]';
    label.id = 'labels';
    label.placeholder="Enter your label here";
    var link = document.createElement('a');
    link.id ="link";
    link.href="#";
    link.innerText ="Add another label";
    link.onclick=function(){
        generateLabelTextArea();
    }


    //append default label to the label div
    labelDiv.appendChild(origionalLabel);
    labelDiv.appendChild(label);
    labelDiv.appendChild(link);

    //generate default  data
    var dataDiv = document.createElement('div');
    dataDiv.id = 'dataText';
    dataDiv.className='dataText';

    var origionalData= document.createElement('LABEL');
    var dataText = document.createTextNode("Data: ");
    origionalData.appendChild(dataText);
    var data = document.createElement('INPUT');
    data.className = 'data';
    data.name ='data[]';
    data.id = 'text';
    data.placeholder="Enter your data value here";
    var links= document.createElement('a');
    links.id ="link1";
    links.href="#";
    links.innerText ="Add another data value";
    links.onclick=function(){
        generateDataTextArea();
    }
    //append default label to the label div
    dataDiv.appendChild(origionalData);
    dataDiv.appendChild(data);
    dataDiv.appendChild(links);

    var br =  document.createElement('br');
    var br2 =document.createElement('br');
    var submitButton = document.createElement('BUTTON');
    submitButton.type="submit";
    submitButton.id="generate";
    submitButton.style = "margin-left:70%;";
    submitButton.onclick=function () {
        init();
    }
    submitButton.value="Generate Charts";
    submitButton.innerText="Generate Charts";




    //append all new elements to the view
    dataForm.appendChild(titleLabel);
    dataForm.appendChild(title);
    dataForm.appendChild(br);
    dataForm.appendChild(subtitleLabel);
    dataForm.appendChild(subtitle);
    dataForm.appendChild(br2);
    dataForm.appendChild(nameLabel);
    dataForm.appendChild(name);
    dataForm.appendChild(labelDiv);
    dataForm.appendChild(dataDiv);
    dataForm.appendChild(submitButton);








}

function init(){
    //create the input values

    //get the input values from the class items
    var label = document.getElementsByClassName("labels");
    var data = document.getElementsByClassName("data");
    var title = document.getElementById('title').value;
    var name = document.getElementById('dataNames').value;
    var subtitle = document.getElementById('subtitle').value;
    if(document.getElementById("generate").onclick){
        document.getElementById('tabs').style.display="inline";
        if(!document.getElementsByClassName("charts").onclick){
            showPie();
        }

        loadPie(title, name,data,label);
        loadBar(title,name,subtitle,data,label);
       // loadLine(title,name,subtitle,data,label);
       loadDoughnut(title,name,subtitle,data,label);
    }
}
function showPie(){
    document.getElementById('pieChart').style.display="inline";
    document.getElementById('pieChart').style.visability="visible";
    document.getElementById('barChart').style.display="none";
    document.getElementById('barChart').style.visability="hidden";
    document.getElementById('lineChart').style.display="none";
    document.getElementById('lineChart').style.visability="hidden";

}

function showBar(){
    document.getElementById('barChart').style.display="inline";
    document.getElementById('barChart').style.visability="visible";
    document.getElementById('pieChart').style.display="none";
    document.getElementById('pieChart').style.visability="hidden";
    document.getElementById('lineChart').style.display="none";
    document.getElementById('lineChart').style.visability="hidden";
}

function showLine(){
    document.getElementById('lineChart').style.display="inline";
    document.getElementById('lineChart').style.visability="visible";
    document.getElementById('pieChart').style.display="none";
    document.getElementById('pieChart').style.visability="hidden";
    document.getElementById('barChart').style.display="none";
    document.getElementById('barChart').style.visability="hidden";
}
//generate data Text box
function generateDataTextArea(){
    //get the div, button and input values
    var element = document.getElementById('dataText');
    var text = document.getElementById('text');
    var addButton = document.getElementById('link1');
    //create the needed elements
    var append = document.createElement('input');
    var newButton = document.createElement("a");
    var br = document.createElement('br');

    //properties for the new button to add
    newButton.className="text";
    newButton.value = "add";
    newButton.href = "#";
    newButton.onclick="genrateDataTextArea()";
    //properties for the new text area
    append.className = "data";
    append.placeholder = "Please Enter your data:";

    //remove the first add button
    element.removeChild(addButton);
    //add the needed properties
    element.appendChild(br);
    element.appendChild(append);
    element.appendChild(addButton);
}
//generate label text box
function generateLabelTextArea(){
    //get the div, button and input values
    var element = document.getElementById('dataLabel');
    var text = document.getElementById('labels');
    var addButton = document.getElementById('link');
    //create the needed elements
    var append = document.createElement('input');
    var newButton = document.createElement("a");
    var br = document.createElement('br');
    //properties for the new button to add
    newButton.className="text";
    newButton.value = "add";
    newButton.href = "#";
    newButton.onclick="genrateLabelTextArea()";
    //properties for the new text area
    append.className = "labels";
    append.placeholder = "Please Enter your data:";
    //remove the first add button
    element.removeChild(addButton);
    //add the needed properties
    element.appendChild(br);
    element.appendChild(append);
    element.appendChild(addButton);
}

//load relevant chart
//load pie chart
function loadPie(title,name,data, label){
    var myArr =[];
    var myA = [];
    var final =[];
    for(var i =0;i<label.length;i++){
        myArr[i]=label[i].value;
        myA[i]=data[i].value;
        final.push({
            name: myArr[i],
            y: parseFloat(myA[i])
        });
    }
    Highcharts.chart('pieChart', {
        chart: {
            plotBackgroundColor: null,
            plotBorderWidth: null,
            plotShadow: false,
            type: 'pie',
            backgroundColor: 'lightgrey'
        },
        title: {
            text: title
        },
        tooltip: {
            pointFormat: '{series.name}: <b>{point.percentage:.1f}%</b>'
        },
        plotOptions: {
            pie: {
                allowPointSelect: true,
                cursor: 'pointer',
                dataLabels: {
                    enabled: true,
                    format: '<b>{point.name}</b>: {point.percentage:.1f} %',
                    style: {
                        color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'
                    }
                }
            }
        },
        series: [{
            name: name,
            colorByPoint: true,
            data: final,
            point: {
            }
        }]
    });
}

function loadBar(title,name,subtitle,data,label){
    var dataArray =[];
    var labelArray=[];
   //var combined_data =[];
    for(var i =0;i<data.length;i++){
        dataArray[i]=parseFloat(data[i].value);
        labelArray[i]=label[i].value;

    }


    //generate bar chart
    Highcharts.chart('barChart', {
        chart: {
            type: 'column',
            backgroundColor: 'lightgrey'
        },
        title: {
            text: title
        },
        subtitle: {
            text: subtitle
        },
        xAxis: {
            categories: labelArray,
            crosshair: true
        },
        yAxis: {
            min: 0,
            title: {
                text: subtitle
            }
        },
        tooltip: {
            headerFormat: '<span style="font-size:10px">{point.key}</span><table>',
            pointFormat: '<tr><td style="color:{series.color};padding:0">{series.name}: </td>' +
            '<td style="padding:0"><b>{point.y:.1f} mm</b></td></tr>',
            footerFormat: '</table>',
            shared: true,
            useHTML: true
        },
        plotOptions: {
            column: {
                pointPadding: 0.2,
                borderWidth: 0
            }
        },
        series:[{
            name: name,
            data: dataArray
        }]
    });
}

function loadDoughnut(title,name,subtitle,data,label) {
    var dataArray =[];
    var labelArray=[];


    //var combined_data =[];
    for(var i =0;i<data.length;i++){
        //dataArray[i]=parseInt(data[i].value);
        dataArray[i]=parseFloat(data[i].value);
        labelArray[i]=label[i].value;


    }


    Highcharts.chart('lineChart', {
        chart: {
            type: 'pyramid',
            marginRight: 100,
            backgroundColor: 'lightgrey'
        },
        title: {
            text: title,
            x: -50
        },
        plotOptions: {
            series: {
                dataLabels: {
                    enabled: true,
                    format: '<b>{point.name}</b> ({point.y:,.0f})',
                    color: (Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black',
                    softConnector: true
                }
            }
        },
        legend: {
            enabled: false
        },
        series: [{
            name: name,
            data: dataArray
        }]
    });
 }
// // //load the line chart with the values
// // function loadLine(title,name,subtitle,data,label){
// //     var dataArray =[];
// //     var labelArray=[];
// //
// //     for(var i =0;i<data.length;i++){
// //         dataArray[i]=parseFloat(data[i].value);
// //         labelArray[i]=label[i].value;
// //
// //     }
// //
// //     //var arr =[[]];
// //    // var labels =['lbale1','label2'];
// //     //var data =[23,45,45];
// //
// //     // for(var x =0;x<label.length;x++){
// //     //   // arr[x]=label[x].value;
// //     //   //
// //     //     for(var i = 0;i<data.length;i++){
// //     //         //       arr[x][i]= [[label[x].value,data[i].value]];
// //     //         //       console.log( arr[x][i]+" ");
// //     //         //   }
// //     // }
// //     // var final = '';
// //     // //if the data array is the same then there is 2 lines to plot
// //     // if (dataArray.length == labelArray.length){
// //     //     for(var x = 0;x <= dataArray.length;x++){
// //     //         final[x]= '[{ name: "+labelArray[x]+",data: "+dataArray[x]+"]}';
// //     //     }
// //     //
// //     // }else{
// //     //     if(label.length == 1) {
// //     //         for (var x = 0; x <= data.length; x++) {
// //     //             final[x]= ' [{ name: " + labelArray[0] + ",data: " + dataArray[x] + "]}';
// //     //         }
// //     //     }
// //     // }
// //
// //
// //     Highcharts.chart('lineChart', {
// //         chart: {
// //             backgroundColor: 'lightgrey'
// //         },
// //         title: {
// //             text: title
// //         },
// //
// //         subtitle: {
// //             text: subtitle
// //         },
// //
// //         yAxis: {
// //             title: {
// //                 text: subtitle
// //             }
// //         },
// //         legend: {
// //             layout: 'vertical',
// //             align: 'right',
// //             verticalAlign: 'middle'
// //         },
// //
// //         plotOptions: {
// //             series: {
// //                 pointStart: dataArray[0]
// //             }
// //         },
// //
// //          series:
// //             [{
// //             name: name,
// //             data: dataArray
// //         }
// //         ]
// //     });
// //
// //
// // }
// //
// //
